<template>
  <div>
    <h2 id="page-heading" data-cy="FabricanteHeading">
      <span v-text="$t('gatewayApp.biologicoFabricante.home.title')" id="fabricante-heading">Fabricantes</span>
      <div class="d-flex justify-content-end">
        <button class="btn btn-info mr-2" v-on:click="handleSyncList" :disabled="isFetching">
          <font-awesome-icon icon="sync" :spin="isFetching"></font-awesome-icon>
          <span v-text="$t('gatewayApp.biologicoFabricante.home.refreshListLabel')">Refresh List</span>
        </button>
        <router-link :to="{ name: 'FabricanteCreate' }" custom v-slot="{ navigate }">
          <button
            @click="navigate"
            id="jh-create-entity"
            data-cy="entityCreateButton"
            class="btn btn-primary jh-create-entity create-fabricante"
          >
            <font-awesome-icon icon="plus"></font-awesome-icon>
            <span v-text="$t('gatewayApp.biologicoFabricante.home.createLabel')"> Create a new Fabricante </span>
          </button>
        </router-link>
      </div>
    </h2>
    <br />
    <div class="alert alert-warning" v-if="!isFetching && fabricantes && fabricantes.length === 0">
      <span v-text="$t('gatewayApp.biologicoFabricante.home.notFound')">No fabricantes found</span>
    </div>
    <div class="table-responsive" v-if="fabricantes && fabricantes.length > 0">
      <table class="table table-striped" aria-describedby="fabricantes">
        <thead>
          <tr>
            <th scope="row" v-on:click="changeOrder('id')">
              <span v-text="$t('global.field.id')">ID</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('nombreFabricante')">
              <span v-text="$t('gatewayApp.biologicoFabricante.nombreFabricante')">Nombre Fabricante</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'nombreFabricante'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('productosFabricanet')">
              <span v-text="$t('gatewayApp.biologicoFabricante.productosFabricanet')">Productos Fabricanet</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'productosFabricanet'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('detalleFabricante')">
              <span v-text="$t('gatewayApp.biologicoFabricante.detalleFabricante')">Detalle Fabricante</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'detalleFabricante'"></jhi-sort-indicator>
            </th>
            <th scope="row"></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="fabricante in fabricantes" :key="fabricante.id" data-cy="entityTable">
            <td>
              <router-link :to="{ name: 'FabricanteView', params: { fabricanteId: fabricante.id } }">{{ fabricante.id }}</router-link>
            </td>
            <td>{{ fabricante.nombreFabricante }}</td>
            <td>{{ fabricante.productosFabricanet }}</td>
            <td>{{ fabricante.detalleFabricante }}</td>
            <td class="text-right">
              <div class="btn-group">
                <router-link :to="{ name: 'FabricanteView', params: { fabricanteId: fabricante.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-info btn-sm details" data-cy="entityDetailsButton">
                    <font-awesome-icon icon="eye"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.view')">View</span>
                  </button>
                </router-link>
                <router-link :to="{ name: 'FabricanteEdit', params: { fabricanteId: fabricante.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-primary btn-sm edit" data-cy="entityEditButton">
                    <font-awesome-icon icon="pencil-alt"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.edit')">Edit</span>
                  </button>
                </router-link>
                <b-button
                  v-on:click="prepareRemove(fabricante)"
                  variant="danger"
                  class="btn btn-sm"
                  data-cy="entityDeleteButton"
                  v-b-modal.removeEntity
                >
                  <font-awesome-icon icon="times"></font-awesome-icon>
                  <span class="d-none d-md-inline" v-text="$t('entity.action.delete')">Delete</span>
                </b-button>
              </div>
            </td>
          </tr>
        </tbody>
        <infinite-loading
          ref="infiniteLoading"
          v-if="totalItems > itemsPerPage"
          :identifier="infiniteId"
          slot="append"
          @infinite="loadMore"
          force-use-infinite-wrapper=".el-table__body-wrapper"
          :distance="20"
        >
        </infinite-loading>
      </table>
    </div>
    <b-modal ref="removeEntity" id="removeEntity">
      <span slot="modal-title"
        ><span
          id="gatewayApp.biologicoFabricante.delete.question"
          data-cy="fabricanteDeleteDialogHeading"
          v-text="$t('entity.delete.title')"
          >Confirm delete operation</span
        ></span
      >
      <div class="modal-body">
        <p id="jhi-delete-fabricante-heading" v-text="$t('gatewayApp.biologicoFabricante.delete.question', { id: removeId })">
          Are you sure you want to delete this Fabricante?
        </p>
      </div>
      <div slot="modal-footer">
        <button type="button" class="btn btn-secondary" v-text="$t('entity.action.cancel')" v-on:click="closeDialog()">Cancel</button>
        <button
          type="button"
          class="btn btn-primary"
          id="jhi-confirm-delete-fabricante"
          data-cy="entityConfirmDeleteButton"
          v-text="$t('entity.action.delete')"
          v-on:click="removeFabricante()"
        >
          Delete
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts" src="./fabricante.component.ts"></script>
